"use strict";
{
    const C3 = self.C3;

    C3.Plugins.EMI_INDO_OpenAi.Instance = class OpenAiInstance extends C3.SDKInstanceBase
    {
        constructor(inst, properties)
        {
            super(inst);


            if (properties)
            {}

            if (typeof cordova == 'undefined')
            {
                return;
            }
            else
            {};

            this.EMI_INDO = C3.Plugins.EMI_INDO_OpenAi.Cnds;
            let OpenAi = cordova.plugins.emiOpenAiPlugin;


            this.resultSuccess = "";

            this.errorMessage = "";

            const self = this;

            let _getCompletionsRequest = (message, apiKey) => {
                OpenAi.completions(
                message, // string
                apiKey, // apiKey https://platform.openai.com/

                (result) => {
                    self.resultSuccess = (result)
                    self.Trigger(self.EMI_INDO.OnResponseSuccess);
                }, (error) => {
                    self.errorMessage = (error)
                    self.Trigger(self.EMI_INDO.OnResponseError);
                });
            }

            this._getCompletionsRequest = _getCompletionsRequest;
        }

        Release()
        {
            super.Release();
        }

        SaveToJson()
        {
            return {
                // data to be saved for savegames
            };
        }

        LoadFromJson(o)
        {
            // load state for savegames
        }

        GetDebuggerProperties()
        {
            return [
            {
                title: "OpenAi",
                properties: [
                    //{name: ".current-animation",	value: this._currentAnimation.GetName(),	onedit: v => this.CallAction(Acts.SetAnim, v, 0) },
                ]
            }];
        }

        // timeline support
        GetPropertyValueByIndex(index)
        {
            return 0;
        }

        SetPropertyValueByIndex(index, value)
        {
            //set property value here
        }
    };
}